%global pkg fuse
%global kernel 5.10.134-17.an8
%define kversion %{kernel}.%{_arch}
%define pkg_version 1.2.3
%define anolis_release 1

Name:        kmod-%{pkg}
Version:     %(echo %{kernel} | sed -E 's/-/~/g; s/\.(an|al)[0-9]+$//g')
Release:     %{pkg_version}~%{anolis_release}%{?dist}
Summary:     FUSE filesystem driver
License:     GPL-2.0
Source0:     kmod-%{pkg}-%{pkg_version}.tar.gz

Provides: kmod-%{pkg}-%{kversion} = %{version}-%{release}
Obsoletes: kmod-%{pkg}-%{kversion} < %{version}-%{release}

Requires:         kernel-uname-r >= %{kversion}

Requires(post):      %{_sbindir}/modinfo
Requires(posttrans): %{_sbindir}/depmod
Requires(postun):    %{_sbindir}/depmod
Requires(posttrans): %{_sbindir}/weak-modules
Requires(postun):    %{_sbindir}/weak-modules
Requires(posttrans): %{_bindir}/sort
Requires(postun):    %{_bindir}/sort

BuildRequires:    kernel-devel   = %{kernel}
BuildRequires:    kernel-headers = %{kernel}
BuildRequires:    kernel-core = %{kernel}
BuildRequires:    elfutils-libelf-devel
BuildRequires:    gcc
BuildRequires:    make
BuildRequires:    system-rpm-config
BuildRequires:    kmod

%description
RPM Package for FUSE filesystem driver

# 大部分情况不需要修改，视具体情况进行修改。
%prep
%setup -q -n kmod-%{pkg}-%{pkg_version}

%build
pushd src
cp -r /usr/src/kernels/%{kversion} .
cp fuse.h ./%{kversion}/include/uapi/linux/
%{__make} -C `pwd`/%{kversion} %{?_smp_mflags} M=$PWD modules
modinfo -F srcversion fuse.ko > fuse.srcversion
popd

%install
mkdir -p %{buildroot}/lib/modules/%{kversion}/extra/fs/%{pkg}
%{__install} -D -t %{buildroot}/lib/modules/%{kversion}/extra/fs/%{pkg} src/fuse.ko
%{__install} -D -t %{buildroot}/lib/modules/%{kversion}/extra/fs/%{pkg} src/cuse.ko
%{__install} -D -t %{buildroot}/lib/modules/%{kversion}/extra/fs/%{pkg} src/virtiofs.ko
%{__install} -D -t %{buildroot}/lib/modules/%{kversion}/extra/fs/%{pkg} src/virtfuse.ko
%{__install} -D -t %{buildroot}/lib/modules/%{kversion}/extra/fs/%{pkg} src/fuse.srcversion

# Make .ko objects temporarily executable for automatic stripping
find %{buildroot}/lib/modules -type f -name \*.ko -exec chmod u+x \{\} \+

%{__install} -d %{buildroot}/%{_sysconfdir}/depmod.d/
for kmod in $(find %{buildroot}/lib/modules/%{kversion}/extra -type f -name \*.ko -printf "%%P\n" | sort)
do
    echo "override $(basename $kmod .ko) * weak-updates/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
    echo "override $(basename $kmod .ko) * extra/$(dirname $kmod)" >> %{buildroot}/%{_sysconfdir}/depmod.d/%{pkg}.conf
done

%clean
%{__rm} -rf %{buildroot}

%post
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    printf '%s\n' "/lib/modules/%{kversion}/extra/fs/%{pkg}/fuse.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kversion}/extra/fs/%{pkg}/cuse.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kversion}/extra/fs/%{pkg}/virtiofs.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
    printf '%s\n' "/lib/modules/%{kversion}/extra/fs/%{pkg}/virtfuse.ko" | /usr/sbin/weak-modules --no-initramfs --add-modules
fi

if [ "$(modinfo -F srcversion -k %{kversion} fuse)" != "$(cat /lib/modules/%{kversion}/extra/fs/%{pkg}/fuse.srcversion)" ]; then
	echo "Error: srcversion mismatch!"
	exit 1
fi

%preun
echo "/lib/modules/%{kversion}/extra/fs/%{pkg}/fuse.ko" >> /var/run/rpm-%{pkg}-modules.list
echo "/lib/modules/%{kversion}/extra/fs/%{pkg}/cuse.ko" >> /var/run/rpm-%{pkg}-modules.list
echo "/lib/modules/%{kversion}/extra/fs/%{pkg}/virtiofs.ko" >> /var/run/rpm-%{pkg}-modules.list
echo "/lib/modules/%{kversion}/extra/fs/%{pkg}/virtfuse.ko" >> /var/run/rpm-%{pkg}-modules.list

%postun
depmod -a > /dev/null 2>&1

if [ -x "/usr/sbin/weak-modules" ]; then
    modules=( $(cat /var/run/rpm-%{pkg}-modules.list) )
    printf '%s\n' "${modules[@]}" | /usr/sbin/weak-modules --no-initramfs --remove-modules
fi
rm /var/run/rpm-%{pkg}-modules.list

%files
%defattr(644,root,root,755)
%license licenses
/lib/modules/%{kversion}
%config(noreplace) %{_sysconfdir}/depmod.d/%{pkg}.conf

%changelog
* Mon Mar 17 2025 Jingbo Xu <@jefflexu@linux.alibaba.com> - 1.2.3-1
- dontcache optimization for buffer read and write

* Wed Jun 13 2024 Jingbo Xu <@jefflexu@linux.alibaba.com> - 1.1.0-1
- Build %{pkg} for %{kversion}
